function setBackColor(r,g,b) love.graphics.setBackgroundColor(r/255,g/255,b/255) end

function loadQuads(w,h,w2,h2)
	local quads={}
	for i=0,w2,w do
		quads[i/w+1]=love.graphics.newQuad(i,0,w,h,w2,h2)
	end
	return quads
end

function newSfx(name)
	return love.audio.newSource("sfx/"..name..".mp3","static")
end

window={}
love.window.setMode(0,0)
window.fullw,window.fullh=love.graphics.getDimensions()
scale=math.min(math.floor(((window.fullw/46)/4)),math.floor(window.fullh/46)+10)
window.w=46*scale*4
window.h=46*scale
love.window.setMode(window.w,window.h,{borderless=true})
love.window.setTitle("curse of Imset")

math.randomseed(os.time())

files={
	"growl",
	"lalala",
	"laugh",
	"normal",
	"whistle",
	"angrymoan",
}
sfx={} shouldPlay={}
for i,s in ipairs(files) do
	sfx[i]={}
	sfx[i][1]=newSfx(s)
	sfx[i][2]=newSfx(s)
	shouldPlay[i]=0
end
files=nil

audio={}
audio.yum=newSfx("yum")
audio.summons=newSfx("summonings")
audio.ow=newSfx("ow")
audio.uhuh=newSfx("uhuh")

song=love.audio.newSource("sfx/song.mp3","stream")
song:setLooping(true)
song:setVolume(0.5)
song:play()

love.graphics.setDefaultFilter("nearest","nearest",0)

transition={}
transition.position=-200
transition.v=0
transition.canLoad=true
transition.canPlay=true

function love.load()
	difficulty=140
	score=0

	gfx={}
	gfx.spritesheet=love.graphics.newImage("gfx/spritesheet.png")
	gfx.cursor=love.graphics.newImage("gfx/cursor.png")
	gfx.quads=loadQuads(46,46,gfx.spritesheet:getDimensions())
	gfx.drawSprite=function(s,x,y)
		love.graphics.draw(gfx.spritesheet,gfx.quads[s],math.floor(x),math.floor(y),0)
	end
	gfx.ui={}
	gfx.ui.spritesheet=love.graphics.newImage("gfx/ui.png")
	gfx.ui.quads=loadQuads(5,5,gfx.ui.spritesheet:getDimensions())
	gfx.font=love.graphics.newImage("gfx/font.png")
	gfx.glyphs=loadQuads(5,5,gfx.font:getDimensions())
	gfx.print=function(v,x,y)
		local text=tostring(v)
		for i=1,#text do
			love.graphics.draw(gfx.font,gfx.glyphs[tonumber(string.sub(text,i,i))+1],x+(i-1)*5-1,y,0)
		end
	end
	gfx.token=love.graphics.newImage("gfx/token.png")

	setBackColor(107,147,255)

	setting={}
	for i=1,4 do
		setting[i]=math.random(11,12)
	end

	patients={}
	patients[1]={
		s=6,
		mode=0,
		active=false,
		summoned=false,
		y=46,
		v=0
	}
	patients[2]={
		s=6,
		mode=0,
		active=false,
		summoned=false,
		y=-100,
		v=0
	}
	patients[3]={
		s=6,
		mode=0,
		active=false,
		summoned=false,
		y=-100,
		v=0
	}

	doctor={}
	doctor.s=13

	time=0

	whistleTimer=0

	mouse={}

	token={}
	token.active=false
	token.pos=1
	token.x=11
	token.y=46
end

function love.update()
	mouse.left=love.mouse.isDown(1)
	mouse.right=love.mouse.isDown(2)
	mouse.x=love.mouse.getX()/scale
	mouse.y=love.mouse.getY()/scale
	if not (mouse.left or mouse.right) then mouse.cp=true end

	time=time+1
	if time>difficulty then
		if difficulty>50 then difficulty=difficulty-2 end
		if difficulty==130 then
			patients[2].y=46
		end
		if difficulty==100 then
			patients[3].y=46
		end
		if difficulty==90 then
			token.y=45
		end

		score=score+1

		time=0
		local activePatients=0
		for i,o in ipairs(patients) do
			if o.active then
				activePatients=activePatients+1
			end
		end

		if activePatients>0 then
			local o=patients[math.random(1,activePatients)]
			if (math.random(1,2)==1 or (o.mode>0)) and (not (o.mode<0)) then
				o.mode=o.mode+1
			else
				o.mode=o.mode-1
			end
		end
	end

	if doctor.s==14 then doctor.s=math.random(13,16) end
	if math.random(1,100)==5 then
		doctor.s=math.random(13,16)
	end

	whistleTimer=whistleTimer+1
	for i=1,#shouldPlay do shouldPlay[i]=0 end
	for i,o in ipairs(patients) do
		if o.active then
			if o.mode==-2 and (math.random(1,10)==10 or o.s<7) then
				o.s=math.random(8,10)
			end
			if o.mode==2 and (math.random(1,10)==10 or o.s>3) then
				o.s=math.random(1,3)
			end
			if o.mode==-2 then
				shouldPlay[1]=shouldPlay[1]+1
			end
			if o.mode==2 then
				shouldPlay[2]=shouldPlay[2]+1
			end
			if o.mode==0 then
				o.s=6
			end
			if o.mode==1 then
				if (o.s~=4 and o.s~=5) or whistleTimer>40 then
					if math.random(1,3)>1 then
						o.s=5
					else
						o.s=4
					end
				end
				shouldPlay[5]=shouldPlay[5]+1
			end
			if o.mode==-1 then
				o.s=7
				shouldPlay[6]=shouldPlay[6]+1
			end
			if o.mode>2 or o.mode<-2 then o.summoned=true end
			if o.summoned then
				o.v=o.v-0.1
				o.y=o.y+o.v
				o.s=17
				if transition.canPlay then
					audio.summons:stop()
					audio.summons:play()
					transition.canPlay=false
					cscore=score
				end
				transition.v=3
			end
			if transition.v>0 then
				o.mode=0
			end
		elseif o.y>0 then
			o.y=o.y-1
			if o.y<1 then
				o.y=0
				o.active=true
			end
		end
	end

	if token.y<46 and not token.active then token.y=token.y-1 if token.y==36 then token.active=true end end

	if token.active then
		local x=token.pos*46-35
		token.x=token.x+(x-token.x)/4
	end

	if transition.v>0 then
		transition.position=transition.position+transition.v
		if transition.position>=46*4 and transition.canLoad then
			love.load()
			transition.canLoad=false
			love.timer.sleep(1)
		end
		if transition.position>=460 then
			transition={}
			transition.position=-200
			transition.v=0
			transition.canLoad=true
			transition.canPlay=true
		end
	end

	if whistleTimer>40 then
		whistleTimer=math.random(1,5)
	end

	--mouse stuff
	if transition.v<1 and mouse.cp then
		if token.active and mouse.left and mouse.y>35 and mouse.x<139 then
			local number=math.floor(mouse.x/46)+1
			local x=token.pos*46-35
			if math.abs(token.x-x)<4 then
				if patients[number].active then
					if number==token.pos then
						if number==1 then
							token.pos=2
						else
							token.pos=1
						end
					else
						token.pos=number
					end
				end
			end
		elseif mouse.left and mouse.x>window.w/scale-6 then
			mouse.cp=false
			if mouse.y<6 then
				love.event.quit()
			elseif mouse.y<13 then
				transition.v=3
				cscore=score
			end
		elseif mouse.left or mouse.right then
			local number=math.floor(mouse.x/46)+1
			local o=patients[number]
			if o and o.active then
				if token.active and token.pos==number then
					audio.uhuh:play()
				else
					if mouse.left then
						mouse.cp=false
						o.mode=o.mode-1
						audio.ow:play()
					elseif mouse.right then
						mouse.cp=false
						o.mode=o.mode+1
						audio.yum:play()
					end
				end
			end
		end
	end

	for i=1,#shouldPlay do
		if shouldPlay[i]>0 then
			if not sfx[i][1]:isPlaying() then
				sfx[i][1]:play()
			end
			if (not sfx[i][2]:isPlaying()) and shouldPlay[i] then
				sfx[i][2]:play()
			elseif shouldPlay[i]==1 then
				sfx[i][2]:stop()
			end
		else
			sfx[i][1]:stop()
			sfx[i][2]:stop()
		end
	end
end


function love.draw()
	love.graphics.scale(scale)

	for i=0,3 do
		gfx.drawSprite(setting[i+1],46*i,0)
	end

	for i,o in ipairs(patients) do
		gfx.drawSprite(o.s,(i-1)*46,o.y)
	end

	gfx.drawSprite(doctor.s,46*3,0)

	love.graphics.draw(gfx.ui.spritesheet,gfx.ui.quads[1],window.w/scale-6,1)
	love.graphics.draw(gfx.ui.spritesheet,gfx.ui.quads[2],window.w/scale-6,7)

	local text=tostring(score)
	gfx.print(text,1,1)

	if token.y<46 then
		love.graphics.draw(gfx.token,token.x,token.y)
	end

	if transition.v>0 then
		gfx.drawSprite(20,transition.position,0)
		for x=transition.position-46,transition.position-46*4,-46 do
			gfx.drawSprite(19,x,0)
		end
		gfx.drawSprite(18,transition.position-46*5,0)

		local text=tostring(cscore)
		gfx.print(text,transition.position-100,18)
	end
end